Subject: Re: [BUG] diffcore-rename with duplicate tree entries can segfault

From: Junio C Hamano <[email-masked]>
Date: Wed, 25 Feb 2015 13:50:38 -0800

Jeff King <[email-masked]> writes:

> But we can also do that with a hash table, or an auxiliary sorted array.
> And sure enough, that's exactly what the rename_dst array is.
> ...
> which I think is a pretty simple and sane fix.

Yeah, good observation.

> So to go forward, I'm happy to prepare a patch, but I'd like to know:
>
>   1. Does something like the above look reasonable to you (I'd probably
>      refactor it to avoid the bizarre return value semantics from
>      locate_rename_dst, though)?
>
>   2. If so, do you want something minimal like what's above, or do you
>      mind if I build it on top of a hashmap conversion? I suspect the
>      logic may also end up more clear with the hashmap (since inserting
>      versus lookup will be more distinct in the callers).

No, I don't mind.  The diff-b-m topic seems to need a lot deeper
rethink than I originally anticipated anyway, and it can wait for a
clean-up to use hashmap to stabilize.

Thanks.